'２次元流跡線V52の標準ﾓｼﾞｭｰﾙ      ［作成］黒田英夫(2023/03)
Imports System.Drawing.Printing

Module FL2LCom
    '２次元および軸対称体の流跡線作画
    '２次元流れ解析「FlowLiq」のデータを利用
    'アイソパラメトリック四角形要素使用

    'V41での改良点・・・流跡線の入力データに節点番号を追加、
    '                   流跡線データ入力画面で節点追加ボタンに変更
    'V42での改良点・・・流跡線の色数を６色から１０色に増加、
    '                   流跡線データの入力画面に色見本を表示、
    '                   流跡線アニメーションを追加
    'V43での改良点・・・２次元流れ解析の非粘性解析追加に対応
    'V44での改良点・・・流跡線の幅を可変化
    'V45での改良点・・・各画面でボタンを読みやすい色に改善
    'V46での改良点・・・Visual Basic 2017に変更
    'V47での改良点・・・プログラムファイルの文字コードをUTF-8に統一、
    '                   データファイルの文字コードを標準でUTF-8に変更
    '                   （従来のShift-JISもオプションで可能）
    'V48での改良点・・・ファイル入出力画面でキャンセル処理の改善
    'V49での改良点・・・ファイル文字コードUTF-8で流跡線自動設定のエラーを修正
    'V50での改良点・・・データ表画面で表計算ソフトから貼り付け時に次行に0が入るのを防止
    'V51での改良点・・・入力データのファイル印刷メニューを廃止
    '                   （文字コードによる不具合のため）
    'V52での改良点・・・フリーソフト化、VB2022に移行、文字コードはUTF-8のみ採用

    Public Cr$                      'CR+LFのコード
    Public DirOpen$                 '立ち上げ時のディレクトリー名
    Public Fm$                      '入力データのファイル名
    Public Fstruct$                 '構造データファイル名
    Public Fy$                      '計算結果のファイル名
    Public Title$                   'タイトル

    Public Timst As Date            '計算開始時刻

    Public IncVisc As Integer       '粘性の有無（0:なし、1:有り）
    Public InOut As Integer         'ファイル入出力の種類（0:入力、1:出力）
    Public Kaxis As Integer         '作図のＸＹ軸の入換え（0:なし、1:有り）
    Public KBodyForce As Integer    '物体力の有無（0:なし、1:有り）
    Public KcomSide As Integer      '要素辺の表示有無（0:なし、1:有り）
    Public KdataBackup As Integer   '入力データのバックアップファイル作成（0:なし、1:有り）
    Public KdataChange As Integer   'データ変更の有無（0:なし、1:有り）
    Public KindFlow As Integer      '流れ種類（0:ﾆｭｰﾄﾝ流、1:非ﾆｭｰﾄﾝ流）
    Public KE1 As Integer           '開始要素番号
    Public KE2 As Integer           '最終要素番号
    Public KfileOK As Integer       'ﾌｧｲﾙのOK有無（0:なし、1:有り）
    '    Public KindEncod As Integer     'ファイルの文字コード（0:UTF-8、1:Shif-JIS）
    Public KindFLSet As Integer     '流跡線数の設定区分（0:入力指定、
    '                                1:自動設定・中間節点除外、2:自動設定・中間節点込み）
    Public KindFLSetb As Integer    '上記の保存変数
    Public KindPost As Integer      '後処理の種別（0:流跡線図、1:流跡線アニメーション）
    Public KindTherm As Integer     '温度変化の種別（0:等温、1:非等温）
    Public KmouseDchange As Integer 'ﾏｳｽ指定要素のﾃﾞｰﾀ変更有無
    Public KmouseElem As Integer    'ﾏｳｽ指定の要素番号
    Public KnewUFileA As Integer    '最近使用ﾌｧｲﾙAの更新有無
    Public KnumDisp As Integer      '構造作画での番号表示（0:なし、1:有り）
    Public KnumSb As Integer        'ﾌｫﾝﾄ文字ｻｲｽﾞの操作変数
    Public KnumSize As Integer      '構造作画での番号ｻｲｽﾞ
    Public Kscreen As Integer       '作画画面サイズ（0：全画面、1：通常画面）
    Public Ktime As Integer         '出力メッシュ番号
    Public Kvisc As Integer         '粘度式の種類（0:なし、1:べき乗、
    '                                2:常用対数、3:自然対数）
    Public MeshStd As Integer       '軸方向長さの基準分割数
    Public Mstat As Integer         '解析種別（０:定常、１:非定常）
    Public Nall As Integer          '変数の総数
    Public Nbound As Integer        '速度・圧力固定の節点数
    Public NBtemp As Integer        '温度固定の節点数
    Public Ndim As Integer          '１節点当りの変数の数(=3、温度を除く)
    Public Nelem As Integer         '要素数
    Public Nflux As Integer         '熱流束境界の辺の数
    Public Nflow, Nflowb As Integer         '流跡線の数
    Public Ngaus As Integer         'ガウス積分点数(=3)
    Public Npoint As Integer        '節点数
    Public Nskip As Integer         '節点の飛ばし数
    Public Ntime As Integer         '非定常の出力時間メッシュ数
    Public Ntype As Integer         '問題のタイプ（2:２次元、4:軸対称）
    Public Nvar As Integer          '１要素当りの変数の総数

    Public Cfix As Single           'XY方向ﾋﾟｸｾﾙ差の補正係数
    Public Ctherm As Single         '比熱
    Public Rou As Single            '密度
    Public Rmyu As Single           '粘度
    Public Rlamda As Single         '熱伝導率
    Public TimeMax As Single        '非定常の打切り時間
    Public XaxisMax As Single       'Ｘ軸の最大値
    Public XaxisMin As Single       'Ｘ軸の最小値
    Public Xlower As Single         '作画領域のX最小値
    Public Xupper As Single         '作画領域のX最大値
    Public XYscale As Single        '作画スケール
    Public YaxisMax As Single       'Ｙ軸の最大値
    Public YaxisMin As Single       'Ｙ軸の最小値
    Public Ylower As Single         '作画領域のY最小値
    Public Yupper As Single         '作画領域のY最大値

    Public ArrText As New ArrayList()

    Public UFileA(6) As String      '最近使用した入力ﾌｧｲﾙの保存配列

    Public JfixP(,) As Integer      '速度・圧力固定の有無(0:固定なし、1:固定有り)
    Public KdrawElem() As Integer   '各要素の作画有無（0:なし、1:有り）
    Public KFcolor() As Integer     '各流跡線の色番号
    Public Kpflux(,) As Integer     '熱流束境界の３節点番号
    Public KSelem(,) As Integer     '各要素面の内部辺指定（0:なし、1：有り）
    Public KsidePoint(3) As Integer '辺の3節点の節点順位
    Public NNelem(,) As Integer     '各要素における全節点番号
    Public NPrefer() As Integer     '要素計算における節点変数の対応番号
    Public NPstart() As Integer     '流跡線の始点の節点番号
    Public Nrest() As Integer       '速度・圧力の節点番号
    Public NTrestP() As Integer     '温度固定の節点番号

    Public Accel(2) As Single       '物体力の加速度
    Public Avisc(5) As Single       '粘度式の係数
    Public Pnorm() As Single        '単位面積当りの垂直熱流束
    Public TempFixP() As Single     '固定温度
    Public Tfp() As Single          'FEM計算の解
    Public VfixP(,) As Single       '速度・圧力の固定値
    Public X(), Y() As Single       '節点座標
    Public XE(8), YE(8) As Single   '要素計算の配列
    Public Xmouse(), Ymouse() As Single 'ﾏｳｽ位置座標
    Public Xstart(), Ystart() As Single '流跡線の始点座標

    Sub AreaCalc(ByRef area As Single, ByVal x1 As Single, _
    ByVal y1 As Single, ByVal x2 As Single, ByVal y2 As Single, _
    ByVal xb As Single, ByVal yb As Single)
        '三角形の符号付き面積算出（最初の2点に対して左側は正、右側は負）
        'area･･･符号付き面積
        'x1,y1,x2,y2･･･2点の座標
        'xb,yb･･･対象点の座標
        area = x1 * y2 - y1 * x2 + x2 * yb - y2 * xb + xb * y1 - yb * x1
    End Sub

    Sub AxisCheck(ByRef icheck As Integer, ByRef k1 As Integer, _
        ByRef k2 As Integer, ByRef ratio As Single, ByRef xmin As Single, _
        ByRef xmax As Single, ByRef ymin As Single, ByRef ymax As Single)
        'X、Y軸の最小・最大値と作画直角回転要否のﾁｪｯｸ
        'icheck･･･作画直角回転要否（0:回転なし、1:直角回転要）
        '         最初に-1が設定された場合は、RZ座標のR最小値は0としない
        'k1,k2･･･要素の開始、終了番号
        'ratio･･･作画直角回転なしの縦横比上限（指定値）
        'xmin･･･X座標最小値
        'xmax･･･X座標最大値
        'ymin･･･Y座標最小値
        'ymax･･･Y座標最大値
        Dim i, ie, ik, j As Integer
        Dim b1, b2, ratiob As Single
        ik = 0
        For ie = k1 To k2
            If KdrawElem(ie) > 0 Then
                For j = 1 To 8
                    i = NNelem(ie, j)
                    If ik = 0 Then
                        ik = 1
                        xmin = X(i) : xmax = xmin
                        ymin = Y(i) : ymax = ymin
                    Else
                        If X(i) < xmin Then
                            xmin = X(i)
                        ElseIf X(i) > xmax Then
                            xmax = X(i)
                        End If
                        If Y(i) < ymin Then
                            ymin = Y(i)
                        ElseIf Y(i) > ymax Then
                            ymax = Y(i)
                        End If
                    End If
                Next j
            End If
        Next ie
        If Ntype = 4 And icheck >= 0 Then
            xmin = 0
        End If
        b1 = xmax - xmin
        b2 = ymax - ymin
        If b1 = 0 Then
            icheck = 0
        Else
            ratiob = b2 / b1
            If ratiob > ratio Then
                icheck = 1
            Else
                icheck = 0
            End If
        End If

    End Sub

    Sub CenterLine(ByVal gr As Graphics, ByVal icheck As Integer)
        '中心線の作画
        'icheck･･･作画直角回転要否（0:回転なし、1:直角回転要）
        'kind･･･ﾋﾟｸﾁｬｰﾎﾞｯｸｽの長さ種類（0:標準、1:大）
        Dim myPen As New Pen(Color.Black)
        myPen.DashStyle = Drawing2D.DashStyle.DashDot
        Select Case icheck
            Case 0
                gr.DrawLine(myPen, Xlower, Ylower, Xlower, Yupper)
            Case 1
                gr.DrawLine(myPen, Xlower, Ylower, Xupper, Ylower)
        End Select

    End Sub

    Sub CfileIn1U(ByVal fxx$)
        '計算結果ﾌｧｲﾙを読込み、等温・非等温の確認
        'UTF-8･･･BOMなし
        'fxx$･･･計算結果ﾌｧｲﾙ名
        Dim aa$

        Dim sr As New IO.StreamReader(fxx$)
        Dim dat() As String

        aa$ = sr.ReadLine
        aa$ = sr.ReadLine
        aa$ = sr.ReadLine
        aa$ = sr.ReadLine
        dat = aa.Split(",")
        Mstat = dat(1)
        If Mstat > 0 Then
            aa$ = sr.ReadLine
            dat = aa.Split(",")
            TimeMax = dat(1)
            Ntime = dat(3)
        End If
        Do
            aa$ = sr.ReadLine
            If aa$ = "等温流" Then
                KindTherm = 0
                Exit Do
            ElseIf aa$ = "非等温流" Then
                KindTherm = 1
                Exit Do
            End If
        Loop

        sr.Close()

    End Sub

    Sub DfileInput2U(ByVal fxx$)
        '構造ﾃﾞｰﾀﾌｧｲﾙの読み込み
        'UTF-8･･･BOMなし
        'fxx$･･･入力ﾌｧｲﾙ名
        Dim aa$
        Dim i, j, jb As Integer

        Dim sr As New IO.StreamReader(fxx$)
        Dim dat() As String

        aa$ = sr.ReadLine
        dat = aa.Split(",")
        If dat(0) <> "プログラム名" Then
            aa$ = "構造のUTF-8データファイルとは違います！"
            MsgBox(aa$, 0, "データエラー")
            sr.Close()
            Exit Sub
        End If
        If dat(1) <> "FlowLiq" Then
            aa$ = "構造データファイルが違います！"
            MsgBox(aa$, 0, "データエラー")
            sr.Close()
            Exit Sub
        End If
        Title$ = sr.ReadLine
        aa$ = sr.ReadLine
        dat = aa.Split(",")
        Ntype = dat(1)
        aa$ = sr.ReadLine
        dat = aa.Split(",")
        IncVisc = dat(1)
        aa$ = sr.ReadLine
        dat = aa.Split(",")
        Npoint = dat(1)
        aa$ = sr.ReadLine
        dat = aa.Split(",")
        Nelem = dat(1)
        aa$ = sr.ReadLine
        dat = aa.Split(",")
        Nbound = dat(1)
        If IncVisc = 1 Then
            aa$ = sr.ReadLine
            dat = aa.Split(",")
            NBtemp = dat(1)
            aa$ = sr.ReadLine
            dat = aa.Split(",")
            Nflux = dat(1)
            aa$ = sr.ReadLine
            dat = aa.Split(",")
            Kvisc = dat(1)
        Else
            aa$ = sr.ReadLine
            dat = aa.Split(",")
            Nflux = dat(1)
        End If
        aa$ = sr.ReadLine
        dat = aa.Split(",")
        KBodyForce = dat(1)
        If IncVisc = 1 Then
            aa$ = sr.ReadLine
            aa$ = sr.ReadLine
        End If
        aa$ = sr.ReadLine
        dat = aa.Split(",")
        Ngaus = dat(1)

        If IncVisc = 1 Then
            aa$ = sr.ReadLine
            dat = aa.Split(",")
            Ndim = dat(1)
        End If

        ReDim NNelem(Nelem, 8)
        ReDim X(Npoint), Y(Npoint)
        ReDim Nrest(Nbound), JfixP(Nbound, Ndim), VfixP(Nbound, Ndim)
        ReDim NTrestP(NBtemp), TempFixP(NBtemp)
        ReDim Kpflux(Nflux, 3), Pnorm(Nflux)

        aa$ = sr.ReadLine
        For i = 1 To Nelem
            aa$ = sr.ReadLine
            dat = aa.Split(",")
            For j = 1 To 8
                NNelem(i, j) = dat(j)
            Next j
        Next i

        aa$ = sr.ReadLine
        For i = 1 To Npoint
            aa$ = sr.ReadLine
            dat = aa.Split(",")
            X(i) = dat(1)
            Y(i) = dat(2)
        Next i

        If Nbound > 0 Then
            aa$ = sr.ReadLine
            For i = 1 To Nbound
                aa$ = sr.ReadLine
                dat = aa.Split(",")
                Nrest(i) = dat(1)
                If IncVisc = 0 Then
                    VfixP(i, 1) = dat(2)
                Else
                    For j = 1 To Ndim
                        jb = 2 * j - 1
                        JfixP(i, j) = dat(jb + 1)
                        VfixP(i, j) = dat(jb + 2)
                    Next j
                End If
            Next i
        End If

        If IncVisc = 1 Then
            If NBtemp > 0 Then
                aa$ = sr.ReadLine
                For i = 1 To NBtemp
                    aa$ = sr.ReadLine
                    dat = aa.Split(",")
                    NTrestP(i) = dat(1)
                    TempFixP(i) = dat(2)
                Next i
            End If
        End If

        If Nflux > 0 Then
            aa$ = sr.ReadLine
            For i = 1 To Nflux
                aa$ = sr.ReadLine
                dat = aa.Split(",")
                Kpflux(i, 1) = dat(1)
                Kpflux(i, 2) = dat(2)
                Kpflux(i, 3) = dat(3)
                Pnorm(i) = dat(4)
            Next i
        End If

        sr.Close()

    End Sub

    Sub DfileInputU(ByVal fxx$)
        '入力ﾃﾞｰﾀﾌｧｲﾙの読み込み
        'UTF-8･･･BOMなし
        'fxx$･･･入力ﾌｧｲﾙ名
        Dim aa$, titleb$
        Dim i As Integer

        Dim sr As New IO.StreamReader(fxx$)
        Dim dat() As String

        aa$ = sr.ReadLine
        dat = aa.Split(",")
        If dat(0) <> "プログラム名" Then
            aa$ = "本ソフトのUTF-8データファイルとは違います！"
            MsgBox(aa$, 0, "データエラー")
            sr.Close()
            Exit Sub
        End If
        If dat(1) <> "FlowLine" Then
            aa$ = "データファイルが違います！"
            MsgBox(aa$, 0, "データエラー")
            sr.Close()
            Exit Sub
        End If
        Title$ = sr.ReadLine
        aa$ = sr.ReadLine
        dat = aa.Split(",")
        Fstruct$ = dat(1)

        titleb$ = Title$
        Try
            Call DfileInput2U(Fstruct$)
        Catch ex As Exception
            aa$ = "構造ファイルを読み込めません！"
            MsgBox(aa$, 0, "データエラー")
            Exit Sub
        End Try
        If titleb$ <> "" Then
            Title$ = titleb$
        End If

        aa$ = sr.ReadLine
        dat = aa.Split(",")
        Fy$ = dat(1)
        aa$ = sr.ReadLine
        dat = aa.Split(",")
        Ntype = dat(1)
        aa$ = sr.ReadLine
        dat = aa.Split(",")
        Nflow = dat(1)

        ReDim KFcolor(Nflow), NPstart(Nflow), Xstart(Nflow), Ystart(Nflow)
        aa$ = sr.ReadLine

        For i = 1 To Nflow
            aa$ = sr.ReadLine
            dat = aa.Split(",")
            KFcolor(i) = dat(1)
            NPstart(i) = dat(2)
            Xstart(i) = dat(3)
            Ystart(i) = dat(4)
        Next i

        sr.Close()

    End Sub

    Sub DfileOutU(ByVal fxx$)
        '入力ﾃﾞｰﾀﾌｧｲﾙへの書き出し
        'UTF-8･･･BOMなし
        'fxx$･･･入力ﾃﾞｰﾀﾌｧｲﾙ名
        Dim a1$, aa$
        Dim i As Integer

        Dim sw As New IO.StreamWriter(fxx$)
        aa$ = "プログラム名" + "," + "FlowLine"
        sw.WriteLine(aa$)
        sw.WriteLine(Title$)
        aa$ = "［構造データファイル］" + "," + Fstruct$
        sw.WriteLine(aa$)
        aa$ = "［解析結果ファイル］" + "," + Fy$
        sw.WriteLine(aa$)
        aa$ = "問題のタイプ" + "," + Str(Ntype)
        sw.WriteLine(aa$)
        aa$ = "流跡線数" + "," + Str(Nflow)
        sw.WriteLine(aa$)

        aa$ = "流跡線指定データ（No.、色番号、節点番号、"
        If Ntype < 4 Then
            a1$ = "始点Ｘ、始点Ｙ）"
        Else
            a1$ = "始点Ｒ、始点Ｚ）"
        End If

        aa$ = aa$ + a1$
        sw.WriteLine(aa$)
        For i = 1 To Nflow
            aa$ = Str$(i) + ",   " + Str$(KFcolor(i))
            aa$ = aa$ + ",   " + Str$(NPstart(i))
            aa$ = aa$ + ",   " + Str$(Xstart(i))
            aa$ = aa$ + ",   " + Str$(Ystart(i))
            sw.WriteLine(aa$)
        Next i

        sw.Close()

        aa$ = "データをファイルへ保存しました。"
        MsgBox(aa$, 0, "ファイル保存完了")

    End Sub

    Sub DrawFocusRect(ByRef gr As Graphics)
        'ﾌｫｰｶｽ矩形の描画
        Dim rect As Rectangle
        Dim p1, p2 As Point

        If Xmouse(1) <= Xmouse(2) Then
            p1.X = Xmouse(1)
            p2.X = Xmouse(2)
        Else
            p1.X = Xmouse(2)
            p2.X = Xmouse(1)
        End If
        If Ymouse(1) <= Ymouse(2) Then
            p1.Y = Ymouse(1)
            p2.Y = Ymouse(2)
        Else
            p1.Y = Ymouse(2)
            p2.Y = Ymouse(1)
        End If
        rect.X = p1.X
        rect.Y = p1.Y
        rect.Width = p2.X - p1.X
        rect.Height = p2.Y - p1.Y

        gr.DrawRectangle(Pens.DarkGray, rect)   '矩形の描画

    End Sub

    Sub DrawScale(ByRef icheck As Integer, ByVal dpixb As Single, _
        ByVal dpiyb As Single, ByVal xlen As Single, ByVal ylen As Single, _
        ByVal xmin As Single, ByVal xmax As Single, _
        ByVal ymin As Single, ByVal ymax As Single)
        '作画倍率の計算
        'icheck･･･作画直角回転要否（0:回転なし、1:直角回転要）
        'dpixb･･･X軸方向のdpi値
        'dpiyb･･･Y軸方向のdpi値
        'xlen･･･作画領域のX方向長さ
        'ylen･･･作画領域のY方向長さ
        'xmin･･･X座標最小値
        'xmax･･･X座標最大値
        'ymin･･･Y座標最小値
        'ymax･･･Y座標最大値
        Dim b1, b2, cx, cy As Single

        Cfix = dpiyb / dpixb

        b1 = xmax - xmin : b2 = ymax - ymin
        Select Case icheck
            Case 0
                If Cfix < 1 Then
                    If b1 <> 0 Then
                        cx = xlen / b1
                    End If
                    If b2 <> 0 Then
                        cy = ylen / b2 / Cfix
                    End If
                Else
                    If b1 <> 0 Then
                        cx = Cfix * xlen / b1
                    End If
                    If b2 <> 0 Then
                        cy = ylen / b2
                    End If
                End If
                If b1 = 0 Then
                    XYscale = cy
                ElseIf b2 = 0 Then
                    XYscale = cx
                ElseIf cy < cx Then
                    XYscale = cy
                Else
                    XYscale = cx
                End If
            Case 1
                If Cfix < 1 Then
                    If b2 <> 0 Then
                        cx = xlen / b2
                    End If
                    If b1 <> 0 Then
                        cy = ylen / b1 / Cfix
                    End If
                Else
                    If b2 <> 0 Then
                        cx = Cfix * xlen / b2
                    End If
                    If b1 <> 0 Then
                        cy = ylen / b1
                    End If
                End If
                If b2 = 0 Then
                    XYscale = cy
                ElseIf b1 = 0 Then
                    XYscale = cx
                ElseIf cy < cx Then
                    XYscale = cy
                Else
                    XYscale = cx
                End If
        End Select

    End Sub

    Sub Elem2DPrep()
        '構造図作画準備
        Dim ie As Integer
        Dim pa, qa, ratio As Single
        ReDim KdrawElem(Nelem)

        KE1 = 1
        KE2 = Nelem
        KnumDisp = 0
        KnumSize = 8
        For ie = KE1 To KE2
            KdrawElem(ie) = 1
        Next ie

        ratio = 1.2
        Kaxis = 0
        Call AxisCheck(Kaxis, 1, Nelem, ratio, XaxisMin, pa, YaxisMin, qa)
        'X、Y軸の最小・最大値と作画直角回転要否のﾁｪｯｸ

    End Sub

    Sub ElemSearch2(ByRef k1 As Integer, ByRef k2 As Integer)
        '拡大作画する要素の探索
        '全節点が指定領域にある要素を採用、作画要素なしの場合は元のﾃﾞｰﾀを保存
        'k1,k2･･･要素の開始、終了番号
        Dim ib, ic, ie, j, kmax, kmin As Integer
        Dim b1, b2 As Single
        Dim kbuf(Nelem) As Integer

        ic = 0
        For ie = 1 To Nelem
            kbuf(ie) = KdrawElem(ie)
            If KdrawElem(ie) > 0 Then
                For j = 1 To 8
                    ib = NNelem(ie, j)
                    b1 = X(ib) - Xmouse(1)
                    b2 = X(ib) - Xmouse(2)
                    If b1 >= 0 And b2 <= 0 Then
                        If Kaxis = 0 Then
                            b1 = Y(ib) - Ymouse(2)
                            b2 = Y(ib) - Ymouse(1)
                        Else
                            b1 = Y(ib) - Ymouse(1)
                            b2 = Y(ib) - Ymouse(2)
                        End If
                        If b1 >= 0 And b2 <= 0 Then
                            If j = 8 Then
                                KdrawElem(ie) = 1
                                If ic = 0 Then
                                    ic = 1
                                    kmin = ie
                                    kmax = ie
                                ElseIf ie < kmin Then
                                    kmin = ie
                                ElseIf ie > kmax Then
                                    kmax = ie
                                End If
                            End If
                        Else
                            KdrawElem(ie) = 0
                            Exit For
                        End If
                    Else
                        KdrawElem(ie) = 0
                        Exit For
                    End If
                Next j
            End If
        Next ie
        k1 = kmin
        k2 = kmax
        If k1 = 0 Then
            For ie = 1 To Nelem
                KdrawElem(ie) = kbuf(ie)
            Next ie
        End If
    End Sub

    Sub FileName(ByVal fxx$, ByRef fxb$)
        'ﾌｧｲﾙ名fxx$の拡張子なしの部分fxb$を取り出す
        Dim i As Integer
        i = InStr(fxx$, ".")
        If i > 0 Then
            fxb$ = Left$(fxx$, i - 1)
        Else
            fxb$ = fxx$
        End If
    End Sub

    Sub InnerCheck(ByRef ic As Integer, ByVal ie As Integer, _
    ByVal xb As Single, ByVal yb As Single)
        '内点ﾁｪｯｸ
        'ic･･･判定結果（-1:外点、0:内点）
        'ie･･･要素番号
        'xb,yb･･･点の座標
        Dim ib, j As Integer
        Dim area, x1, x2, y1, y2 As Single

        ic = 0
        ib = NNelem(ie, 8)
        x2 = X(ib) : y2 = Y(ib)
        For j = 1 To 8
            x1 = x2 : y1 = y2
            ib = NNelem(ie, j)
            x2 = X(ib) : y2 = Y(ib)
            Call AreaCalc(area, x1, y1, x2, y2, xb, yb) '三角形の符号付き面積算出
            If area < 0 Then
                ic = -1
                Exit For
            End If
        Next j

    End Sub

    Sub MouseCalc2()
        'ﾏｳｽ点のﾓﾃﾞﾙ座標への変換
        Dim j As Integer
        Dim xa, xb, ya, yb As Single
        For j = 1 To 2
            xa = Xmouse(j)
            ya = Ymouse(j)
            If Cfix < 1 Then
                If Kaxis = 0 Then
                    xb = (xa - Xlower) / XYscale + XaxisMin
                    yb = (Yupper - ya) / XYscale / Cfix + YaxisMin
                Else
                    xb = (ya - Ylower) / XYscale / Cfix + XaxisMin
                    yb = (xa - Xlower) / XYscale + YaxisMin
                End If
            Else
                If Kaxis = 0 Then
                    xb = Cfix * (xa - Xlower) / XYscale + XaxisMin
                    yb = (Yupper - ya) / XYscale + YaxisMin
                Else
                    xb = (ya - Ylower) / XYscale + XaxisMin
                    yb = Cfix * (xa - Xlower) / XYscale + YaxisMin
                End If
            End If
            Xmouse(j) = xb
            Ymouse(j) = yb
        Next j

    End Sub

    Sub NodePointSet()
        '始点の節点番号の設定
        Dim i, ip, j, k, nb As Integer

        For i = 1 To Nflow
            k = 0
            For ip = 1 To Nelem
                For j = 1 To 8
                    nb = NNelem(ip, j)
                    If Xstart(i) = X(nb) And Ystart(i) = Y(nb) Then
                        k = nb
                        Exit For
                    End If
                Next j
            Next ip
            NPstart(i) = k
        Next i

    End Sub

    Sub NumCheck(ByRef ic As Integer, ByRef i1 As Integer, _
        ByRef i2 As Integer, ByRef j1 As Integer, _
        ByRef j2 As Integer)
        '要素辺の重なりのﾁｪｯｸ
        'ic･･･要素辺の重なり有無（0:なし、1:有り）
        'i1･･･第1の辺の一端の節点番号
        'i2･･･第1の辺の他端の節点番号
        'j1･･･第2の辺の一端の節点番号
        'j2･･･第2の辺の他端の節点番号
        ic = 0
        If i1 = j1 Then
            If i2 = j2 Then
                ic = 1
            End If
        ElseIf i1 = j2 Then
            If i2 = j1 Then
                ic = 1
            End If
        End If

    End Sub

    Sub OptFileIn()
        'ｵﾌﾟｼｮﾝ･ﾌｧｲﾙ読み込み
        Dim ftmp$

        ftmp$ = DirOpen$ + "\FL2LMenu.tmp"
        Try
            Dim sr As New IO.StreamReader(ftmp$)
            KdataBackup = Val(sr.ReadLine)
            Kscreen = Val(sr.ReadLine)
            KcomSide = Val(sr.ReadLine)
            sr.Close()
        Catch
            '処理不要
        End Try

    End Sub

    Sub OptFileOut()
        'ｵﾌﾟｼｮﾝ･ﾌｧｲﾙ書き出し
        Dim ftmp$

        ftmp$ = DirOpen$ + "\FL2LMenu.tmp"
        Dim sw As New IO.StreamWriter(ftmp$)
        sw.WriteLine(KdataBackup)
        sw.WriteLine(Kscreen)
        sw.WriteLine(KcomSide)
        sw.Close()

    End Sub

    Sub OutlineDraw(ByRef gr As Graphics, ByVal icheck As Integer, _
        ByVal k1 As Integer, ByVal k2 As Integer)
        '指定要素範囲の外形の作画
        'gr･･･ｸﾞﾗﾌｨｯｸｽ･ｵﾌﾞｼﾞｪｸﾄ名
        'icheck･･･作画時のXY入れ替えの有無（0:なし、1:有り）
        'k1･･･作画初めの要素番号
        'k2･･･作画終りの要素番号
        Dim i, i1, i2, ic, ie, ii, j, j1, j2, jj As Integer
        Dim xi, xj, yi, yj As Single
        Dim kmulti(Nelem, 8) As Integer
        For ie = k1 To k2
            If KdrawElem(ie) > 0 Then
                i1 = NNelem(ie, 8)
                For j = 1 To 8
                    i2 = NNelem(ie, j)
                    For ii = ie + 1 To k2
                        If KdrawElem(ii) > 0 Then
                            j1 = NNelem(ii, 8)
                            For jj = 1 To 8
                                j2 = NNelem(ii, jj)
                                Call NumCheck(ic, i1, i2, j1, j2)
                                '要素辺の重なりﾁｪｯｸ

                                If ic = 1 Then
                                    kmulti(ie, j) = 1
                                    kmulti(ii, jj) = 1
                                End If
                                j1 = j2
                            Next jj
                        End If
                    Next ii
                    i1 = i2
                Next j
            End If
        Next ie

        For ie = k1 To k2
            If KdrawElem(ie) > 0 Then
                i = NNelem(ie, 8)
                xi = X(i)
                yi = Y(i)
                Call XYCalc2(icheck, xi, yi)  'X,Yの作画座標計算
                For ii = 1 To 8
                    j = NNelem(ie, ii)
                    xj = X(j)
                    yj = Y(j)
                    Call XYCalc2(icheck, xj, yj)  'X,Yの作画座標計算
                    If kmulti(ie, ii) = 0 Then
                        gr.DrawLine(Pens.Black, xi, yi, xj, yj)
                    End If
                    xi = xj : yi = yj
                Next ii
            End If
        Next ie

    End Sub

    Sub TimCal(ByVal ktim As Integer, ByRef timn$)
        'ﾀｲﾏｰ計算
        'ktim･･･時間継続指定（0:時間ｸﾘｱする、1:時間継続する）
        'timn$･･･時分秒に換算した経過時間
        Dim rtime As Date = Now
        Dim rhour, rmin, sec As Single
        If ktim > 0 Then
            sec = DateDiff(DateInterval.Second, Timst, rtime)
            rhour = Int(sec / 3600) : sec = sec - rhour * 3600
            rmin = Int(sec / 60) : sec = Int(sec - rmin * 60)
            timn$ = Str$(rhour) + "h" + Str$(rmin) + "min" + Str$(sec) + "s"
        Else
            Timst = rtime
        End If
    End Sub

    Sub TmpFileIn()
        'ﾃﾝﾎﾟﾗﾘｰ･ﾌｧｲﾙ読み込み
        Dim ftmp$

        ftmp$ = DirOpen$ + "\FlowLine.tmp"
        Try
            Dim sr As New IO.StreamReader(ftmp$)
            Fstruct$ = sr.ReadLine
            Fm$ = sr.ReadLine
            Fy$ = sr.ReadLine
            sr.Close()
        Catch
            '処理不要
        End Try

    End Sub

    Sub TmpFileOut()
        'ﾃﾝﾎﾟﾗﾘｰ･ﾌｧｲﾙ書き出し
        Dim ftmp$

        ftmp$ = DirOpen$ + "\FlowLine.tmp"
        Dim sw As New IO.StreamWriter(ftmp$)
        sw.WriteLine(Fstruct$)
        sw.WriteLine(Fm$)
        sw.WriteLine(Fy$)
        sw.Close()

    End Sub

    Sub UFileAddA()
        'UFileAの追加処理
        Dim i, ic, j As Integer
        ic = 0
        For i = 2 To 6
            If UFileA(i) = UFileA(0) Then
                For j = i - 1 To 0 Step -1
                    UFileA(j + 1) = UFileA(j)
                Next j
                ic = 1
                Exit For
            End If
        Next i
        If ic = 0 Then
            For i = 5 To 0 Step -1
                UFileA(i + 1) = UFileA(i)
            Next i
        End If
        UseFileAOut()       'ﾃﾝﾎﾟﾗﾘｰ･ﾌｧｲﾙ書き出し

    End Sub

    Sub UseFileAIn()
        'ﾃﾝﾎﾟﾗﾘｰ･ﾌｧｲﾙ読み込み
        Dim ftmp$
        Dim i As Integer

        ftmp$ = DirOpen$ + "\FL2LUFileA.tmp"
        Try
            Dim sr As New IO.StreamReader(ftmp$)
            i = 0
            Do Until sr.Peek = -1 'ﾌｧｲﾙ末尾まで
                i = i + 1
                UFileA(i) = sr.ReadLine
            Loop
            sr.Close()
        Catch
            '処理不要
        End Try

    End Sub

    Sub UseFileAOut()
        'ﾃﾝﾎﾟﾗﾘｰ･ﾌｧｲﾙ書き出し
        Dim ftmp$
        Dim i As Integer

        ftmp$ = DirOpen$ + "\FL2LUFileA.tmp"
        Dim sw As New IO.StreamWriter(ftmp$)
        For i = 1 To 6
            If UFileA(i) <> "" Then
                sw.WriteLine(UFileA(i))
            Else
                Exit For
            End If
        Next i
        sw.Close()

    End Sub

    Sub XYCalc2(ByRef icheck As Integer, ByRef xb As Single, _
        ByRef yb As Single)
        'X,Yの作画座標計算
        'icheck･･･作画時のXY入れ替えの有無（0:なし、1:有り）
        'xb･･･X座標値
        'yb･･･Y座標値
        Dim b1, b2 As Single
        b1 = xb - XaxisMin
        b2 = yb - YaxisMin
        If Cfix < 1 Then
            If icheck = 0 Then
                xb = b1 * XYscale + Xlower
                yb = Yupper - b2 * XYscale * Cfix
            Else
                xb = b2 * XYscale + Xlower
                yb = b1 * XYscale * Cfix + Ylower
            End If
        Else
            If icheck = 0 Then
                xb = b1 * XYscale / Cfix + Xlower
                yb = Yupper - b2 * XYscale
            Else
                xb = b2 * XYscale / Cfix + Xlower
                yb = b1 * XYscale + Ylower
            End If
        End If
    End Sub

End Module
